(*************************************************
PvlUrl is a simple component that will launch the default browser
and jump to a specified URL. It bypasses some of the hassles of just using
Shell execute the URL.

Additional Properties
   Url : The Url to show;
   UrlShowCommand : How to show the browser e.g. maximzed,minimized etc;
Additional Methods
   Connect : Launch the browser.

This Source Code remains Copyrighted to
CopyRight (c) 1997 PA van Lonkhuyzen

It may be distributed/modified/used freely.

The Author may be contacted via
email peterv@global.co.za
post P A van Lonkhuyzen
     PO Box 1041
     Randpark Ridge
     2156
     South Africa
***************************************************)
{$D-,L-} {Remove if you wish to debug this code}
unit pvlUrl;

interface

uses
  Windows,classes,sysutils;

type
  TUrlShowCmd = (ssHide,ssMaximize,ssMinimize,ssRestore,ssShow,ssShowDefault,ssShowMaximized,ssShowMinimized,ssShowMinNoActivate,ssShowNA,ssShowNoActivate,ssShowNormal);
  TpvlUrl = class(TComponent)
  private
    fUrl : String;
    fUrlShowCommand : TUrlShowCmd;
    Function regkey(key : HKey;subkey : string; var data : string) : LongInt;
  protected
  public
    constructor Create(AParent : TComponent); override;
    procedure Connect;
  published
    property UrlShowCommand : TUrlShowCmd read fUrlShowCommand write fUrlShowCommand default ssShowDefault;
    property Url : String read fUrl write fUrl;
  end;

procedure Register;

implementation

Function TpvlUrl.regkey(key : HKey;subkey : string; var data : string) : LongInt;
var
    h : Hkey;
    tdata : array[0..259] of char;
    DSize : integer;
begin
  result:=regopenkeyex(key,pchar(subkey),0,KEY_QUERY_VALUE,h);
  if result=ERROR_SUCCESS then
  begin
    DSize:=Sizeof(Tdata);
    regqueryvalue(h,nil,tdata,DSize);
    data:=strpas(tdata);
    regclosekey(h);
  end;
end;

constructor TpvlUrl.Create(AParent : TComponent);
begin
  inherited;
  fUrlShowCommand:=ssShowDefault;
end;

procedure TpvlUrl.Connect;
var show : integer;
    key : string;
    p : integer;

begin
  case fUrlShowCommand of
   ssHide           : show:=sw_Hide;
   ssMaximize       : show:=sw_Maximize;
   ssMinimize       : show:=sw_Minimize;
   ssRestore        : show:=sw_Restore;
   ssShow           : show:=sw_Show;
   ssShowDefault    : show:=sw_ShowDefault;
   ssShowMaximized  : show:=sw_ShowMaximized;
   ssShowMinimized  : show:=sw_ShowMinimized;
   ssShowMinNoActivate : show:=sw_ShowMinNoActive;
   ssShowNA         : show:=sw_ShowNA;
   ssShowNoActivate : show:=sw_ShowNoActivate;
   else show:=sw_ShowNormal
  end;

  if RegKey(HKEY_CLASSES_ROOT,'.htm',key)=ERROR_SUCCESS then
  begin
    key:=key+'\shell\open\command';
    if RegKey(HKEY_CLASSES_ROOT,key,key)=ERROR_SUCCESS then
    begin
      p:=pos('"%1"',key);
      if p=0 then
        p:=pos('%1',key);
      if p<>0 then
       setlength(key,p-1);
      key:=key+' '+furl;
      if winexec(pchar(key),show)<32 then
        raise exception.create('Couldn''t launch default browser');
    end;
  end;
end;

procedure Register;
begin
  RegisterComponents('Peter''s Components', [TpvlUrl]);
end;

end.
